<?php
#
# (C) Hans-J. Barthen, DL5DI
#     Franz-Josef-Str. 20
#     D-56642 Kruft
#
# Copyright (c) 2008-2012 Hans-J. Barthen - DL5DI
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
#
#-----------------------------------------------------------------------------
# Revision history:
#
# 20111113: dl5di, initial testversion
# 20120608: dl5di, changed to new tcpdump format

error_reporting(E_ERROR | E_WARNING | E_PARSE);

$debug = 0;

$database = "DMR";
$user = "dmruser";
$pw = "egal";
$host = "127.0.0.1";
$table = "Log";

# read command parameter, we need 'datetime', 'rptrid', 'seq' and 'ts'
if((isset($_GET['dt'])) && (isset($_GET['rid'])) && (isset($_GET['seq'])) && (isset($_GET['ts']))){
    $dt = $_GET['dt'];
    $rid = $_GET['rid'];
    $seq = $_GET['seq'];
    $ts = $_GET['ts'];
} else {
    exit;
}

$link = mysql_connect($host,$user);
if (!$link) {
    die('no connection to database: ' . mysql_error());
}

mysql_select_db($database,$link);

$sql = "SELECT from_call,rptr_call,grp_name,rawdata FROM Log WHERE date_time=$dt AND rptr_id='$rid' AND seq='$seq' AND ts='$ts'";

if($debug > 0){
    print $sql . "\n";
}

$result = mysql_query("$sql");

while($data = mysql_fetch_array($result)){
    $src_call = $data['from_call'];
    $rptr_call = $data['rptr_call'];
    $grp_name = $data['grp_name'];
    $raw_data = $data['rawdata'];

if($debug > 0){
    echo "<br>" . $src_call . "<br>";
}

#
# Format of input string:
# 2011-11-13 10:52:04 0 84 00 262440 139 2624420 2624415 01 00 00 2e 66 20 80 dd 01 65 74 54 d5 67 53 00 00 00
# date       time     c o0 o1 rptr_id s  src_id  dest_id o12.................o19 020.......................029
#
# New format of input string:
# 2012-06-05 21:45:09 50000 80 262510 237 2626010 2624415 02 00006da0 20 80 dd 50820 0f5cc863 0 01 80 11 84 0a 96
# date       time     port  o0 rptr_id s  src_id  dest_id o12 flctrl  o17o18o19 seq  timestmp s o30o31 l 34 35 dz
#
# c: client-id
# s: sequence number
# o#: octed number (octed 0-12 DMR = header, octed 20-29 = appended data : TCP/IP header, GPS etc.)
#

    list($oct0,$rptr_id,$seq,$src_id,$dest_id,$oct12,$flctl,$oct17,$oct18,$oct19,$seqnum,$tstamph,$sync,$o30,$o31,$words,$o34,$o35,$dsize) = explode(" ",$raw_data,19);

}

if($debug > 0){
    print $raw_data . "<br>";
}

mysql_close($link);

?>


<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>DMR IP-Side Header</title>
<meta name="description" content="Header description of DMR transmissions on IP-side ">
<meta name="keywords" content="DMR Hamradio Amateur-Radio Amateurfunk DARC VUS DL5DI ">
<meta name="author" content="DL5DI">
<meta name="editor" content="html-editor phase 5">
</head>
<body text="#000000" bgcolor="#FFFFFF" link="#FF0000" alink="#FF0000" vlink="#FF0000">


<!-- Headline -->
<h3>Header of transmission</h3>
<br>
<?php 
    $dt = substr($dt,1,19);
    print $dt." from ".$src_call." to ".$grp_name." via ".$rptr_call."<br>Rawdata:  ". $raw_data ."\n";
?>
<P>
<table width="800" border="1" cellpadding="0" cellspacing="2" allign="center">
 <tr>
  <td align="center">Offset in<br>Dumpfile</td>
  <td align="center">Octet</td>
  <td align="center" width="200">H</td>
  <td align="center" width="200">L</td>
  <td align="center">Values/Comments</td>
 </tr>

<!-- Octet 0 -->


 <tr>
  <td align="center">1/47-48</td>
  <td align="center">0</td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=100% colspan="4">Format</th>
             </tr>
             <tr>
<?php
	      $o = "00" . $oct0;
	      $oh = substr($o,-2,2);
	      $sb = "00000000" . decbin(hexdec($oh));
	      $s = substr($sb,-8,8);
	      $hbyteb = substr($s,0,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
             <tr>
<?php
		$hex = substr($o,-2,1);
                print"<td width=100% align=\"center\" colspan=\"4\">$hex</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
      </table>
  </td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;</th>
              <th width=25% bgcolor='0000FF'><font color='white'>A</font></th>
              <th width=25%>&nbsp;</th>
              <th width=25% bgcolor='FF5F00'>G/I</th>
             </tr>
             <tr>
<?php
	      $lbyteb = substr($s,4,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($lbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\" bgcolor='0000FF'><font color='white'>" . $bita[1] . "</font></td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\" bgcolor='FF5F00'>" . $bita[3] ."</td>";
?>
             </tr>
             <tr>
<?php
		$hex = substr($o,-1,1);
                print"<td width=100% align=\"center\" colspan=\"4\">$hex</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
      </table>
  </td>

  <td  align="center">
<?php
    print "Hex: " . $oh . "<br> Dec: " . hexdec($oh);
	if($bita[3] == 1){ 
        print "<br><b>Individual Call</b>"; 
    } elseif($bita[1] == 1){
	print "<br><b>Answer requested (Individual)</b>";
    } else {
	print "<br><b>Group Call</b>";
    }
?>
  </td>
 </tr>

<!-- Octet 1-4 -->
 <tr>
  <td align="center">1/51-55<br>2/9-11</td>
  <td align="center">1-4</td>
  <td align="center" bgcolor='FFFF00'>
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
	     <tr>
<?php
	      $rptr_idb = "000000000000000000000000000000000" . decbin($rptr_id);
	      $ridb = substr($rptr_idb,-32,32);
	      $hbyteb = substr($ridb,0,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] ."</td>";
?>
             </tr>

	     <tr>
	      <td align="center" colspan="4">
<?php
		$ridh = "000000" . dechex($rptr_id);
		$hex = substr($ridh,-8,1);
		print $hex;
?>
	      </td>
	     </tr>

	     <tr>
<?php
	      $hbyteb = substr($ridb,8,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] ."</td>";
?>
             </tr>

             <tr>
	      <td align="center" colspan="4">
<?php
		$hex = substr($ridh,-6,1);
		print $hex;
?>
	      </td>
	     </tr>


	     <tr>
<?php
	      $hbyteb = substr($ridb,16,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] ."</td>";
?>
             </tr>

             <tr>
	      <td align="center" colspan="4">
<?php
		$hex = substr($ridh,-4,1);
		print $hex;
?>
	      </td>
	     </tr>
             <tr>
             <tr>
<?php
	      $hbyteb = substr($ridb,24,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] ."</td>";
?>
	     </tr>
             <tr>
	      <td align="center" colspan="4">
<?php
		$hex = substr($ridh,-2,1);
		print $hex;
?>
	      </td>
	     </tr>
            </table>
        </td>
       </tr>
      </table>
  </td>
  <td align="center" bgcolor='FFFF00'>
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
	     <tr>
<?php
	      $hbyteb = substr($ridb,4,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] ."</td>";
?>
             </tr>
	     <tr>
	      <td align="center" colspan="4">
<?php
		$hex = substr($ridh,-7,1);
		print $hex;
?>
	      </td>
	     </tr>

	     <tr>
<?php
	      $hbyteb = substr($ridb,12,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] ."</td>";
?>
             </tr>
	     <tr>
	      <td align="center" colspan="4">
<?php
		$hex = substr($ridh,-5,1);
		print $hex;
?>
	      </td>
	     </tr>

	     <tr>
<?php
	      $hbyteb = substr($ridb,20,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] ."</td>";
?>
             </tr>
	     <tr>
	      <td align="center" colspan="4">
<?php
		$hex = substr($ridh,-3,1);
		print $hex;
?>
	      </td>
	     </tr>
             <tr>
<?php
	      $hbyteb = substr($ridb,28,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] ."</td>";
?>
	     </tr>
	     <tr>
	      <td align="center" colspan="4">
<?php
		$hex = substr($ridh,-1,1);
		print $hex;
?>
	      </td>
            </table>
        </td>
       </tr>
      </table>
  </td>

<?php
	$hex = substr($ridh,-8,8);
        print "<td align=\"center\">Repeater-ID (32 bit):<br>Hex: " . $hex . "<br>Dec: " . $rptr_id . "<br><b>" . $rptr_call . "</b></td>";
?>
 </tr>

<!-- Octet 5 -->

 <tr>
  <td align="center">2/12-13</td>
  <td align="center">5</td>
  <td align="center" bgcolor='00FFFF'>
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
<?php
	      $s = "00000000" . decbin($seq);
	      $sb = substr($s,-8,8);
	      $hbyteb = substr($sb,0,4);
	      $lbyteb = substr($sb,4,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] ."</td>";
?>
             </tr>
             <tr>
<?php
	      $hex = "00" . dechex($seq);
	      $hh = substr($hex,-2,1);
	      $hl = substr($hex,-1,1);
              print "<td align=\"center\" colspan=\"4\">" . $hh . "</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
      </table>
  </td>
  <td align="center" bgcolor='00FFFF'>
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
<?php
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($lbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] ."</td>";
?>
             </tr>
             <tr>
<?php
              print "<td align=\"center\" colspan=\"4\">" . $hl . "</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
      </table>
  </td>

<?php
  print "<td align=\"center\">Sequence number (8 bit)<br>Hex: " . substr($hex,-2,2) . "<br>Dec: " . $seq . "</td>";

?>
 </tr>

<!-- Octet 6-8 -->

 <tr>
  <td align="center">2/15-21</td>
  <td align="center">6-8</td>
  <td align="center" bgcolor='00FF00'>
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
	     <tr>
<?php
	      $src_idb = "0000000000000000000000000" . decbin($src_id);
	      $sidb = substr($src_idb,-24,24);
	      $hbyteb = substr($sidb,0,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] ."</td>";
?>
             </tr>
	     <tr>
	      <td align="center" colspan="4">
<?php
		$sidh = "000000" . dechex($src_id);
		$hex = substr($sidh,-6,1);
		print $hex;
?>
	      </td>
	     </tr>
             <tr>
<?php
	      $hbyteb = substr($sidb,8,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] ."</td>";
?>
             </tr>
             <tr>
	      <td align="center" colspan="4">
<?php
		$hex = substr($sidh,-4,1);
		print $hex;
?>
	      </td>
	     </tr>
	     <tr>
<?php
	      $hbyteb = substr($sidb,16,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] ."</td>";
?>
	     </tr>
             <tr>
	      <td align="center" colspan="4">
<?php
		$hex = substr($sidh,-2,1);
		print $hex;
?>
	      </td>
	     </tr>
             <tr>
            </table>
        </td>
       </tr>
      </table>
  </td>
  <td align="center" bgcolor='00FF00'>
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
	     <tr>
<?php
	      $hbyteb = substr($sidb,4,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] ."</td>";
?>
             </tr>
	     <tr>
	      <td align="center" colspan="4">
<?php
		$hex = substr($sidh,-5,1);
		print $hex;
?>
	      </td>
	     </tr>
	     <tr>
<?php
	      $hbyteb = substr($ridb,12,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] ."</td>";
?>
             </tr>
	     <tr>
	      <td align="center" colspan="4">
<?php
		$hex = substr($sidh,-3,1);
		print $hex;
?>
	      </td>
	     </tr>
	     <tr>
<?php
	      $hbyteb = substr($sidb,20,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] ."</td>";
?>
             </tr>
	     <tr>
	      <td align="center" colspan="4">
<?php
		$hex = substr($sidh,-1,1);
		print $hex;
?>
	      </td>
	     </tr>
            </table>
        </td>
       </tr>
      </table>
  </td>

<?php
	$hex = substr($sidh,-6,6);
        print "<td align=\"center\">Source-ID (24 bit):<br>Hex: " . substr($sidh,-6,6) . "<br>Dec: " . $src_id . "<br><b>" . $src_call . "</b></td>";
?>
 </tr>


<!-- Octed 9-11 -->

 <tr>
  <td align="center">2/22-28</td>
  <td align="center">9-11</td>
  <td align="center" bgcolor='FFBF00'>
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
	     <tr>
<?php
	      $dest_idb = "0000000000000000000000000" . decbin($dest_id);
	      $didb = substr($dest_idb,-24,24);
	      $hbyteb = substr($didb,0,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] ."</td>";
?>
             </tr>
	     <tr>
	      <td align="center" colspan="4">
<?php
		$didh = "000000" . dechex($dest_id);
		$hex = substr($didh,-6,1);
		print $hex;
?>
	      </td>
	     </tr>
             <tr>
<?php
	      $hbyteb = substr($didb,8,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] ."</td>";
?>
             </tr>
             <tr>
	      <td align="center" colspan="4">
<?php
		$hex = substr($didh,-4,1);
		print $hex;
?>
	      </td>
	     </tr>
             <tr>
<?php
	      $hbyteb = substr($didb,16,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] ."</td>";
?>
             </tr>
             <tr>
	      <td align="center" colspan="4">
<?php
		$hex = substr($didh,-2,1);
		print $hex;
?>
	      </td>
	     </tr>
            </table>
        </td>
       </tr>
      </table>
  </td>
  <td align="center" bgcolor='FFBF00'>
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
	     <tr>
<?php
	      $lbyteb = substr($didb,4,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($lbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] ."</td>";
?>
             </tr>
	     <tr>
	      <td align="center" colspan="4">
<?php
		$hex = substr($didh,-5,1);
		print $hex;
?>
	      </td>
	     </tr>
	     <tr>
<?php
	      $lbyteb = substr($didb,12,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($lbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] ."</td>";
?>
             </tr>
	     <tr>
	      <td align="center" colspan="4">
<?php
		$hex = substr($didh,-3,1);
		print $hex;
?>
	      </td>
	     </tr>
	     <tr>
<?php
	      $lbyteb = substr($didb,20,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($lbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] ."</td>";
?>
             </tr>
	     <tr>
	      <td align="center" colspan="4">
<?php
		$hex = substr($didh,-1,1);
		print $hex;
?>
	      </td>
	     </tr>
            </table>
        </td>
       </tr>
      </table>
  </td>

<?php
	$hex = substr($didh,-6,6);
        print "<td align=\"center\">Destination-ID (24 bit):<br>Hex: " . substr($didh,-6,6) . "<br>Dec: " . $dest_id . "<br><b>" . $grp_name . "</b></td>";
?>
 </tr>

<!-- Octed 12 -->

 <tr>
  <td align="center">2/30-31</td>
  <td align="center">12</td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
             </tr>
	     <tr>
<?php
	      $o = "00" . $oct12;
	      $oh = substr($o,-2,2);
	      $sb = "00000000" . decbin(hexdec($oh));
	      $s = substr($sb,-8,8);
	      $hbyteb = substr($s,0,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
       <tr>
        <td align="center">
<?php
		$hex = substr($o,-2,1);
		print $hex;
?>
	</td>
       </tr>
      </table>
  </td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
              <th bgcolor='AFAFAF'>V</th>
              <th bgcolor='AFAFAF'>D</th>
             </tr>
             <tr>
<?php
	      $lbyteb = substr($s,4,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($lbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td bgcolor='AFAFAF' align=\"center\">" . $bita[2] . "</td>";
              print "<td bgcolor='AFAFAF' align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
       <tr>
        <td align="center">
<?php
		$hex = substr($o,-1,1);
		print $hex;
?>
	</td>
       </tr>
      </table>
  </td>

<?php
  print"<td align=\"center\">Hex: " . $oh . "<br> Dec: " . hexdec($oh);
  if($hex == 1){
    print "<br><b>DATA</b></td>";
  } else {
    print "<br><b>VOICE</b></td>";
  }
?>
 </tr>


<!-- Octet 13 -->

 <tr>
  <td align="center">2/32-33</td>
  <td align="center">13</td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
             </tr>
             <tr>
<?php
	      $o = "00" . $oct13;
	      $oh = substr($o,-2,2);
	      $sb = "00000000" . decbin(hexdec($oh));
	      $s = substr($sb,-8,8);
	      $hbyteb = substr($s,0,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
       <tr>
        <td align="center">
<?php
		$hex = substr($o,-2,1);
		print $hex;
?>
	</td>
       </tr>
      </table>
  </td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
             </tr>
             <tr>
<?php
	      $lbyteb = substr($s,4,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($lbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
    	    <tr>
    	       <td align="center">
<?php
		$hex = substr($o,-1,1);
		print $hex;
?>
	       </td>
    	    </tr>
        </td>
       </tr>
      </table>
  </td>

<?php
  print"<td align=\"center\">Hex: " . $oh . "<br> Dec: " . hexdec($oh) . "</td>"
?>
 </tr>


<!-- Octet 14 -->

 <tr>
  <td align="center">2/35-36</td>
  <td align="center">14</td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
             </tr>
             <tr>
<?php
	      $o = "00" . $oct14;
	      $oh = substr($o,-2,2);
	      $sb = "00000000" . decbin(hexdec($oh));
	      $s = substr($sb,-8,8);
	      $hbyteb = substr($s,0,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
       <tr>
        <td align="center">
<?php
		$hex = substr($o,-2,1);
		print $hex;
?>
	</td>
       </tr>
      </table>
  </td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
             </tr>
             <tr>
<?php
	      $lbyteb = substr($s,4,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($lbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
    	    <tr>
    	       <td align="center">
<?php
		$hex = substr($o,-1,1);
		print $hex;
?>
	       </td>
    	    </tr>
        </td>
       </tr>
      </table>
  </td>

<?php
  print"<td align=\"center\">Hex: " . $oh . "<br> Dec: " . hexdec($oh) . "</td>"
?>

 </tr>


<!-- Octet 15 -->

 <tr>
  <td align="center">2/37-38</td>
  <td align="center">15</td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
             </tr>
             <tr>
<?php
	      $o = "00" . $oct15;
	      $oh = substr($o,-2,2);
	      $sb = "00000000" . decbin(hexdec($oh));
	      $s = substr($sb,-8,8);
	      $hbyteb = substr($s,0,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
       <tr>
        <td align="center">
<?php
		$hex = substr($o,-2,1);
		print $hex;
?>
	</td>
       </tr>
      </table>
  </td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
             </tr>
             <tr>
<?php
	      $lbyteb = substr($s,4,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($lbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
    	    <tr>
    	       <td align="center">
<?php
		$hex = substr($o,-1,1);
		print $hex;
?>
	       </td>
    	    </tr>
        </td>
       </tr>
      </table>
  </td>
<?php
  print"<td align=\"center\">Hex: " . $oh . "<br> Dec: " . hexdec($oh) . "</td>"
?>
 </tr>

<!-- Octet 16 -->

 <tr>
  <td align="center">2/40-41</td>
  <td align="center">16</td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
             </tr>
             <tr>
<?php
	      $o = "00" . $oct16;
	      $oh = substr($o,-2,2);
	      $sb = "00000000" . decbin(hexdec($oh));
	      $s = substr($sb,-8,8);
	      $hbyteb = substr($s,0,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
       <tr>
        <td align="center">
<?php
		$hex = substr($o,-2,1);
		print $hex;
?>
	</td>
       </tr>
      </table>
  </td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
             </tr>
             <tr>
<?php
	      $lbyteb = substr($s,4,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($lbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
    	    <tr>
    	       <td align="center">
<?php
		$hex = substr($o,-1,1);
		print $hex;
?>
	       </td>
    	    </tr>
        </td>
       </tr>
      </table>
  </td>
<?php
  print"<td align=\"center\">Hex: " . $oh . "<br> Dec: " . hexdec($oh) . "</td>"
?>
 </tr>

<!-- Octet 17 -->

 <tr>
  <td align="center">2/42-43</td>
  <td align="center">17</td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25% bgcolor='00C070'>F</th>
              <th width=25% bgcolor='FF0000'>TS</th>
              <th width=25%>&nbsp;&nbsp;</th>
             </tr>
             <tr>
<?php
	      $o = "00" . $oct17;
	      $oh = substr($o,-2,2);
	      $sb = "00000000" . decbin(hexdec($oh));
	      $s = substr($sb,-8,8);
	      $hbyteb = substr($s,0,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\" bgcolor='00C070'>" . $bita[1] . "</td>";
              print "<td align=\"center\" bgcolor='FF0000'>" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
       <tr>
        <td align="center">
<?php
		$hex = substr($o,-2,1);
		if($hex & 2){ $ts = "<b>2</b>"; } else { $ts = "<b>1</b>"; }
		if($hex & 4){ $fr = "Final"; }
		print $hex;
?>
	</td>
       </tr>
      </table>
  </td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
             </tr>
             <tr>
<?php
	      $lbyteb = substr($s,4,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($lbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
       <tr>
    	       <td align="center">
<?php
		$hex = substr($o,-1,1);
		print $hex;
?>
	       </td>
       </tr>
      </table>
  </td>
<?php
  print"<td align=\"center\">Hex: " . $oh . "<br> Dec: " . hexdec($oh) . "<br><b>Timeslot " . $ts . "</b><br><b>" . $fr ."</b></td>";
?>
 </tr>

<!-- Octet 18 -->

 <tr>
  <td align="center">2/45-46</td>
  <td align="center">18</td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
             </tr>
             <tr>
<?php
	      $o = "00" . $oct18;
	      $oh = substr($o,-2,2);
	      $sb = "00000000" . decbin(hexdec($oh));
	      $s = substr($sb,-8,8);
	      $hbyteb = substr($s,0,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
       <tr>
        <td align="center">
<?php
		$hex = substr($o,-2,1);
		print $hex;
?>
	</td>
       </tr>
      </table>
  </td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
             </tr>
             <tr>
<?php
	      $lbyteb = substr($s,4,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($lbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
       <tr>
        <td align="center">
<?php
		$hex = substr($o,-1,1);
		print $hex;
?>
	</td>
       </tr>
      </table>
  </td>
<?php
  print"<td align=\"center\">Hex: " . $oh . "<br> Dec: " . hexdec($oh) . "</td>"
?>
 </tr>

<!-- Octet 19 -->

 <tr>
  <td align="center">2/45-46</td>
  <td align="center">19</td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25% bgcolor='000000'><font color='white'>?</font></th>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
             </tr>
             <tr>
<?php
	      $o = "00" . $oct19;
	      $oh = substr($o,-2,2);
	      $sb = "00000000" . decbin(hexdec($oh));
	      $s = substr($sb,-8,8);
	      $hbyteb = substr($s,0,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\" bgcolor='000000'><font color='white'>" . $bita[0] . "</font></td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
       <tr>
        <td align="center">
<?php
		$hex = substr($o,-2,1);
		print $hex;
?>
	</td>
       </tr>
      </table>
  </td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25% bgcolor='000000'><font color='white'>?</font></th>
              <th width=25% bgcolor='000000'><font color='white'>?</font></th>
             </tr>
             <tr>
<?php
	      $lbyteb = substr($s,4,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($lbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\" bgcolor='000000'><font color='white'>" . $bita[2] . "</font></td>";
              print "<td align=\"center\" bgcolor='000000'><font color='white'>" . $bita[3] . "</font></td>";
?>
             </tr>
            </table>
        </td>
       </tr>
       <tr>
        <td align="center">
<?php
		$hex = substr($o,-1,1);
		print $hex;
?>
	</td>
       </tr>
      </table>
  </td>

  <td><font size=-1 color='grey'>DPF? (GPS, ARS or TCP/IP)<br>H-Byte:<br>5->short data/d->raw<br>L-Byte:<br>usually 'd'/'e' in data mode</font></td>
 </tr>

<!-- Octet 20 -->

 <tr>
  <td align="center">3/10-11</td>
  <td align="center">20</td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
             </tr>
             <tr>
<?php
	      $o = "00" . $oct20;
	      $oh = substr($o,-2,2);
	      $sb = "00000000" . decbin(hexdec($oh));
	      $s = substr($sb,-8,8);
	      $hbyteb = substr($s,0,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
       <tr>
        <td align="center">
<?php
		$hex = substr($o,-2,1);
		print $hex;
?>
	</td>
       </tr>
      </table>
  </td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
             </tr>
             <tr>
<?php
	      $lbyteb = substr($s,4,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($lbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
       <tr>
        <td align="center">
<?php
		$hex = substr($o,-1,1);
		print $hex;
?>
	</td>
       </tr>
      </table>
  </td>
<?php
  print"<td align=\"center\">Hex: " . $oh . "<br> Dec: " . hexdec($oh) . "</td>"
?>
 </tr>

<!-- Octet 21 -->

 <tr>
  <td align="center">3/12-13</td>
  <td align="center">21</td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
             </tr>
             <tr>
<?php
	      $o = "00" . $oct21;
	      $oh = substr($o,-2,2);
	      $sb = "00000000" . decbin(hexdec($oh));
	      $s = substr($sb,-8,8);
	      $hbyteb = substr($s,0,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
       <tr>
        <td align="center">
<?php
		$hex = substr($o,-2,1);
		print $hex;
?>
	</td>
       </tr>
      </table>
  </td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
             </tr>
             <tr>
<?php
	      $lbyteb = substr($s,4,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($lbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
       <tr>
        <td align="center">
<?php
		$hex = substr($o,-1,1);
		print $hex;
?>
	</td>
       </tr>
      </table>
  </td>
<?php
  print"<td align=\"center\">Hex: " . $oh . "<br> Dec: " . hexdec($oh) . "</td>"
?>
 </tr>

<!-- Octet 22 -->

 <tr>
  <td align="center">3/15-16</td>
  <td align="center">22</td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
             </tr>
             <tr>
<?php
	      $o = "00" . $oct22;
	      $oh = substr($o,-2,2);
	      $sb = "00000000" . decbin(hexdec($oh));
	      $s = substr($sb,-8,8);
	      $hbyteb = substr($s,0,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
       <tr>
        <td align="center">
<?php
		$hex = substr($o,-2,1);
		print $hex;
?>
	</td>
       </tr>
      </table>
  </td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
             </tr>
             <tr>
<?php
	      $lbyteb = substr($s,4,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($lbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
       <tr>
        <td align="center">
<?php
		$hex = substr($o,-1,1);
		print $hex;
?>
	</td>
       </tr>
      </table>
  </td>
<?php
  print"<td align=\"center\">Hex: " . $oh . "<br> Dec: " . hexdec($oh) . "</td>"
?>
 </tr>

<!-- Octet 23 -->

 <tr>
  <td align="center">3/17-18</td>
  <td align="center">23</td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
             </tr>
             <tr>
<?php
	      $o = "00" . $oct23;
	      $oh = substr($o,-2,2);
	      $sb = "00000000" . decbin(hexdec($oh));
	      $s = substr($sb,-8,8);
	      $hbyteb = substr($s,0,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
       <tr>
        <td align="center">
<?php
		$hex = substr($o,-2,1);
		print $hex;
?>
	</td>
       </tr>
      </table>
  </td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
             </tr>
             <tr>
<?php
	      $lbyteb = substr($s,4,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($lbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
       <tr>
        <td align="center">
<?php
		$hex = substr($o,-1,1);
		print $hex;
?>
	</td>
       </tr>
      </table>
  </td>
<?php
  print"<td align=\"center\">Hex: " . $oh . "<br> Dec: " . hexdec($oh) . "</td>"
?>
 </tr>

<!-- Octet 24 -->

 <tr>
  <td align="center">3/20-21</td>
  <td align="center">24</td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
             </tr>
             <tr>
<?php
	      $o = "00" . $oct24;
	      $oh = substr($o,-2,2);
	      $sb = "00000000" . decbin(hexdec($oh));
	      $s = substr($sb,-8,8);
	      $hbyteb = substr($s,0,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
       <tr>
        <td align="center">
<?php
		$hex = substr($o,-2,1);
		print $hex;
?>
	</td>
       </tr>
      </table>
  </td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
             </tr>
             <tr>
<?php
	      $lbyteb = substr($s,4,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($lbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
       <tr>
        <td align="center">
<?php
		$hex = substr($o,-1,1);
		print $hex;
?>
	</td>
       </tr>
      </table>
  </td>
<?php
  print"<td align=\"center\">Hex: " . $oh . "<br> Dec: " . hexdec($oh) . "</td>"
?>
 </tr>

<!-- Octet 25 -->

 <tr>
  <td align="center">3/22-23</td>
  <td align="center">25</td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
             </tr>
             <tr>
<?php
	      $o = "00" . $oct25;
	      $oh = substr($o,-2,2);
	      $sb = "00000000" . decbin(hexdec($oh));
	      $s = substr($sb,-8,8);
	      $hbyteb = substr($s,0,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
       <tr>
        <td align="center">
<?php
		$hex = substr($o,-2,1);
		print $hex;
?>
	</td>
       </tr>
      </table>
  </td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
             </tr>
             <tr>
<?php
	      $lbyteb = substr($s,4,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($lbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
       <tr>
        <td align="center">
<?php
		$hex = substr($o,-1,1);
		print $hex;
?>
	</td>
       </tr>
      </table>
  </td>
<?php
  print"<td align=\"center\">Hex: " . $oh . "<br> Dec: " . hexdec($oh) . "</td>"
?>
 </tr>

<!-- Octet 26 -->

 <tr>
  <td align="center">3/25-26</td>
  <td align="center">26</td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
             </tr>
             <tr>
<?php
	      $o = "00" . $oct26;
	      $oh = substr($o,-2,2);
	      $sb = "00000000" . decbin(hexdec($oh));
	      $s = substr($sb,-8,8);
	      $hbyteb = substr($s,0,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
       <tr>
        <td align="center">
<?php
		$hex = substr($o,-2,1);
		print $hex;
?>
	</td>
       </tr>
      </table>
  </td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
             </tr>
             <tr>
<?php
	      $lbyteb = substr($s,4,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($lbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
       <tr>
        <td align="center">
<?php
		$hex = substr($o,-1,1);
		print $hex;
?>
	</td>
       </tr>
      </table>
  </td>
<?php
  print"<td align=\"center\">Hex: " . $oh . "<br> Dec: " . hexdec($oh) . "</td>"
?>
 </tr>

<!-- Octet 27 -->

 <tr>
  <td align="center">3/27-28</td>
  <td align="center">27</td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
             </tr>
             <tr>
<?php
	      $o = "00" . $oct27;
	      $oh = substr($o,-2,2);
	      $sb = "00000000" . decbin(hexdec($oh));
	      $s = substr($sb,-8,8);
	      $hbyteb = substr($s,0,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
       <tr>
        <td align="center">
<?php
		$hex = substr($o,-2,1);
		print $hex;
?>
	</td>
       </tr>
      </table>
  </td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
             </tr>
             <tr>
<?php
	      $lbyteb = substr($s,4,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($lbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
       <tr>
        <td align="center">
<?php
		$hex = substr($o,-1,1);
		print $hex;
?>
	</td>
       </tr>
      </table>
  </td>
<?php
  print"<td align=\"center\">Hex: " . $oh . "<br> Dec: " . hexdec($oh) . "</td>"
?>
 </tr>

<!-- Octet 28 -->

 <tr>
  <td align="center">3/30-31</td>
  <td align="center">28</td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
             </tr>
             <tr>
<?php
	      $o = "00" . $oct28;
	      $oh = substr($o,-2,2);
	      $sb = "00000000" . decbin(hexdec($oh));
	      $s = substr($sb,-8,8);
	      $hbyteb = substr($s,0,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
       <tr>
        <td align="center">
<?php
		$hex = substr($o,-2,1);
		print $hex;
?>
	</td>
       </tr>
      </table>
  </td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
             </tr>
             <tr>
<?php
	      $lbyteb = substr($s,4,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($lbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
       <tr>
        <td align="center">
<?php
		$hex = substr($o,-1,1);
		print $hex;
?>
	</td>
       </tr>
      </table>
  </td>
<?php
  print"<td align=\"center\">Hex: " . $oh . "<br> Dec: " . hexdec($oh) . "</td>"
?>
 </tr>

<!-- Octet 29 -->

 <tr>
  <td align="center">3/32-33</td>
  <td align="center">29</td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
              <th width=25%>&nbsp;&nbsp;</th>
             </tr>
             <tr>
<?php
	      $o = "00" . $oct29;
	      $oh = substr($o,-2,2);
	      $sb = "00000000" . decbin(hexdec($oh));
	      $s = substr($sb,-8,8);
	      $hbyteb = substr($s,0,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($hbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
       <tr>
        <td align="center">
<?php
		$hex = substr($o,-2,1);
		print $hex;
?>
	</td>
       </tr>
      </table>
  </td>
  <td align="center">
      <table width="200" border="1" cellpadding="0" cellspacing="2">
       <tr>
        <td align="center">
            <table width="100%" border="1" cellpadding="0" cellspacing="2">
             <tr>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
              <th width=25%>&nbsp;</th>
             </tr>
             <tr>
<?php
	      $lbyteb = substr($s,4,4);
	      for($i = 0; $i < 4; $i++){
		$bita[$i] = substr($lbyteb,$i,1);
	      }
              print "<td align=\"center\">" . $bita[0] . "</td>";
              print "<td align=\"center\">" . $bita[1] . "</td>";
              print "<td align=\"center\">" . $bita[2] . "</td>";
              print "<td align=\"center\">" . $bita[3] . "</td>";
?>
             </tr>
            </table>
        </td>
       </tr>
       <tr>
        <td align="center">
<?php
		$hex = substr($o,-1,1);
		print $hex;
?>
	</td>
       </tr>
      </table>
  </td>
<?php
  print"<td align=\"center\">Hex: " . $oh . "<br> Dec: " . hexdec($oh) . "</td>"
?>
 </tr>

</table>


</body>
</html>